# customizations

This configuration section contains settings for configuring customizations.

{% hint style="info" %}
The customizations described here are [Enterprise features](/specsync/jira/licensing.md).
{% endhint %}

The following example shows the available options within this section.

```javascript
{
  ...
 "customizations": {
    "fieldDefaults": {
      "enabled": true,
      "defaultValues": {
        "MyCompany.MyCustomField": "Default 1",
        "MyCompany.OtherCustomField": "Default 2"
      }
    },
    "customFieldUpdates": {
      "enabled": true,
      "updates": {
        "System.Description": "Synchronized from feature {feature-name}{br}{feature-description}"
      }
    },
    "ignoreTestCaseSteps": {
      "enabled": true,
      "ignoredPrefixes": [ "COMMENT" ]
    },
    "ignoreTestCaseTags": {
      "enabled": true,
      "tags": [ "mytag", "ado-tag*" ]
    },
    "ignoreNotSupportedLocalTags": {
      "enabled": true,
      "supportedTags": [ "@myTag", "@otherTag" ]
    }    
    "tagTextMapTransformation": {
      "enabled": true,
      "textMap": {
        "_": " "
      }
    },
    "branchTag": {
      "enabled": true,
      "prefix": "tc.mybranch"
    },
    "linkOnChange": {
      "enabled": true,
      "links": [
        {
          "targetId": "{env:CURRENT_STORY}",
        }
      ]
    },
    "synchronizeLinkedResourceTitles": {
      "enabled": true,
      "linkTagPrefixes": [ "story" ]
    },
    "doNotSynchronizeTitle": {
      "enabled": true
    }
  }
  ...
}
```

## Available customizations

### fieldDefaults

Enables setting default values to test case fields. Useful for custom Jira process templates. See [Customization: Setting Test Case fields with default values](/specsync/jira/features/push-features/customization-setting-test-case-fields-with-default-values.md) for details.

| Setting                       | Description                                                                                                                                                                                       | Default   |
| ----------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | --------- |
| `fieldDefaults/enabled`       | Enables the customization.                                                                                                                                                                        | `false`   |
| `fieldDefaults/defaultValues` | A list of key-value pair, where the key is the canonical name of the field to be updated (e.g. `System.Description`) and the value is the default value to be used when the test case is created. | mandatory |

The `fieldDefaults` customization setting is a shortcut for configuring the [`synchronization/fieldUpdates` section](https://github.com/specsolutions/specsync-jira-documentation/blob/main/reference/configuration/configuration-synchronization-fieldupdates.md). The example above is equivalent to the following `fieldUpdates` setting:

```javascript
{
  "synchronization": {
    "fieldUpdates": {
      "MyCompany.MyCustomField": {
        "value": "Default 1",
        "update": "onCreate"
      },
      "MyCompany.OtherCustomField": {
        "value": "Default 2",
        "update": "onCreate"
      }
    }
  },
}
```

### customFieldUpdates

Enables updating test case fields that are normally not changed by SpecSync. See [Customization: Update custom Test Case fields on push](/specsync/jira/features/push-features/customization-update-custom-test-case-fields-on-push.md) for details.

| Setting                      | Description                                                                                                                                                                                                                                                                                                                                                                                 | Default   |
| ---------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | --------- |
| `customFieldUpdates/enabled` | Enables the customization.                                                                                                                                                                                                                                                                                                                                                                  | `false`   |
| `customFieldUpdates/updates` | A list of key-value pair, where the key is the canonical name of the field to be updated (e.g. `System.Description`) and the value is the template to be used to update the field. The template can contain placeholders listed in the [reference](/specsync/jira/reference/configuration/configuration-synchronization/configuration-synchronization-fieldupdates.md#update-placeholders). | mandatory |

The `customFieldUpdates` customization setting is a shortcut for configuring the [`synchronization/fieldUpdates` section](https://github.com/specsolutions/specsync-jira-documentation/blob/main/reference/configuration/configuration-synchronization-fieldupdates.md). The example above is equivalent to the following `fieldUpdates` setting:

```javascript
{
  "synchronization": {
    "fieldUpdates": {
      "System.Description": {
        "value": "Synchronized from feature {feature-name}{br}{feature-description}"
      }
    }
  },
}
```

### ignoreTestCaseSteps

Can ignore (leave unchanged) test case steps with a specific prefix. See [Customization: Ignoring marked Test Case steps](/specsync/jira/features/push-features/customization-ignoring-marked-test-case-steps.md) for details.

| Setting                               | Description                                                                                                                                     | Default   |
| ------------------------------------- | ----------------------------------------------------------------------------------------------------------------------------------------------- | --------- |
| `ignoreTestCaseSteps/enabled`         | Enables the customization.                                                                                                                      | `false`   |
| `ignoreTestCaseSteps/ignoredPrefixes` | An array of prefixes. The test case steps that start with any of the listed prefixes (case-insensitive) will be ignored by the synchronization. | mandatory |

### ignoreTestCaseTags

Can ignore (leave unchanged) test case tags. See [Customization: Ignoring Test Case Tags](/specsync/jira/features/push-features/customization-ignoring-test-case-tags.md) for details.

| Setting                      | Description                                                                                                                                                                                                                                                                          | Default   |
| ---------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ | --------- |
| `ignoreTestCaseTags/enabled` | Enables the customization.                                                                                                                                                                                                                                                           | `false`   |
| `ignoreTestCaseTags/tags`    | An array of tag specifiers. The tag specifier can be a tag (e.g. `mytag`) or a tag prefix with tailing wildcard (e.g. `ado-tag*` - ignores tags like `ado-tag-important`). The test case tags that match to any of the listed tag specifiers will be ignored by the synchronization. | mandatory |

### ignoreNotSupportedLocalTags

Can be used to specify supported tags. SpecSync will only synchronize the supported tags and ignore all others. See [Customization: Ignore non-supported local tags](/specsync/jira/features/push-features/customization-ignore-non-supported-local-tags.md) for details.

| Setting                                        | Description                                                                                                                                                                                                                                                       | Default                         |
| ---------------------------------------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------- |
| `ignoreNotSupportedLocalTags/enabled`          | Enables the customization.                                                                                                                                                                                                                                        | `false`                         |
| `ignoreNotSupportedLocalTags/supportedTags`    | The list of local (scenario) tags that can be synchronized to Jira. The list can contain full tag names (e.g. `@my-tag1`) or tag name patterns with wildcards (e.g. `@my-tag*`, `@area-*-enabled`).                                                               | empty (no tags are supported)   |
| `ignoreNotSupportedLocalTags/notSupportedTags` | The list of local (scenario) tags that cannot be synchronized to Jira. This setting cannot be used together with 'supportedTags'. The list can contain full tag names (e.g. `@my-tag1`) or tag name patterns with wildcards (e.g. `@my-tag*`, `@area-*-enabled`). | `supportedTags` setting is used |

### tagTextMapTransformation

Can substitute characters or sub-strings in tags when synchronizing to Jira. E.g. underscores (`_`) in scenario tags can be represented with spaces in Test Case tags. See [Customization: Mapping tags](/specsync/jira/features/push-features/customization-mapping-tags.md) for details.

| Setting                            | Description                                                                                                                             | Default   |
| ---------------------------------- | --------------------------------------------------------------------------------------------------------------------------------------- | --------- |
| `tagTextMapTransformation/enabled` | Enables the customization.                                                                                                              | `false`   |
| `tagTextMapTransformation/textMap` | Character or substring replacement rules in 'X':'Y' format, where 'X' is a substring in Gherkin tag and 'Y' is a substring in Jira tag. | mandatory |

### branchTag

Supports synchronization of scenarios on feature branches. See [Customization: Synchronizing scenarios from feature branches](/specsync/jira/features/push-features/customization-support-synchronizing-scenarios-from-a-branch.md) for details.

| Setting             | Description                                                                                                                                               | Default   |
| ------------------- | --------------------------------------------------------------------------------------------------------------------------------------------------------- | --------- |
| `branchTag/enabled` | Enables the customization.                                                                                                                                | `false`   |
| `branchTag/prefix`  | The tag prefix to be used for linking scenarios that are updated on a branch. E.g. the prefix `tc.mybranch` will generate tags, like `@tc.mybranch:1234`. | mandatory |

### linkOnChange

Allows linking changed Test Cases to a work item or pull request, related to the change. See [Customization: Automatically link changed Test Cases](/specsync/jira/features/push-features/customization-automatically-link-changed-test-cases.md) for details.

| Setting                             | Description                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 | Default                        |
| ----------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------ |
| `linkOnChange/enabled`              | Enables the customization.                                                                                                                                                                                                                                                                                                                                                                                                                                                                  | `false`                        |
| `linkOnChange/links[]/targetId`     | The ID of the work item or pull request to link the Test Case to. Placeholders, like `{env:ENVIRONMENT_VARIABLE}` can be used.                                                                                                                                                                                                                                                                                                                                                              | mandatory                      |
| `linkOnChange/links[]/targetType`   | The type of the Jira work item the link refers to. It is verified at the time the link is established.                                                                                                                                                                                                                                                                                                                                                                                      | can link to any work item type |
| `linkOnChange/links[]/relationship` | Specify the relationship for the created link. E.g. specifying `Parent` means that the linked work item will be the parent of the test case work item. For linking Pull Requests it has to be set to `Pull Request` and `GitHub Pull Request` for GitHub Pull Requests (see details in our [guide](https://github.com/specsolutions/specsync-jira-documentation/blob/main/important-concepts/how-to-link-github-pull-requests.md#linking-github-pull-requests-when-the-test-case-changes)). | `Tests`                        |
| `linkOnChange/links[]/linkTemplate` | Specifies the HTTP link template of the related artifact. The link template can use the specified value using the `{id}` placeholder.                                                                                                                                                                                                                                                                                                                                                       | no template used               |

### synchronizeLinkedResourceTitles

Allows synchronizing linked artifact (issue) titles back to the local test case tags in `@story:P01-123;This_is_the_story_title` format. See [Customization: Synchronize linked resource titles](/specsync/jira/features/push-features/customization-sync-linked-artifact-titles.md) for details.

| Setting                                           | Description                                 | Default   |
| ------------------------------------------------- | ------------------------------------------- | --------- |
| `synchronizeLinkedResourceTitles/enabled`         | Enables the customization.                  | `false`   |
| `synchronizeLinkedResourceTitles/linkTagPrefixes` | Specifies the issue links to be considered. | mandatory |

### doNotSynchronizeTitle

Skips synchronizing the Test Case title field (*Summary*, *Name*). See [Customization: Do not synchronize title](/specsync/jira/features/push-features/customization-do-not-synchronize-title.md) for details.

| Setting                         | Description                | Default |
| ------------------------------- | -------------------------- | ------- |
| `doNotSynchronizeTitle/enabled` | Enables the customization. | `false` |

{% content-ref url="/pages/As0iwTwtwwMJKOfZACmA" %}
[Configuration reference](/specsync/jira/reference/configuration.md)
{% endcontent-ref %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.specsolutions.eu/specsync/jira/reference/configuration/configuration-customizations.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
